#ifndef HINVARIANTFACTORY_H
#define HINVARIANTFACTORY_H

#include <string>
#include <memory>
#include <TMath.h>
#include "hparticle.h"
#include "hnparticle.h"
#include "hparticles.h"
#include "hparticlepool.h"
#include "hpoolfactory.h"

using namespace FilteringUtil;

class HInvariantFactory : public HPoolFactory
{
 public:

   HInvariantFactory(HParticlePool& ref, std::string name);
   virtual ~HInvariantFactory();

   void combine();

   void add(EParticle p1);
   void add(EParticle p1, EParticle p2);
   void add(EParticle p1, EParticle p2, EParticle p3);
   void add(EParticle p1, EParticle p2, EParticle p3, EParticle p4);

   bool isMissing() const { return false; }
};

#endif // HINVARIANTFACTORY_H
