#include <iostream>
#include <string>
#include <TError.h>
#include "hmatrixfile.h"


// ****************************************************************************
ClassImp(HMatrixFile)


//-----------------------------------------------------------------------------
HMatrixFile::HMatrixFile(const char* name) : HFile() 
{
   if (0 != name)
   {
      open(name);
   }
}


//-----------------------------------------------------------------------------
HMatrixFile::~HMatrixFile()
{
}


//-----------------------------------------------------------------------------
Bool_t HMatrixFile::open(const char* name, const char*)
{
   std::string tmp_name(name);
   if ( tmp_name.find(".root") != std::string::npos )
   {
      add( name, "read" );
      std::cout << "Adding matrix file: " << name << std::endl;
   }
   else 
   {
      std::cerr << "Unknown matrix file type (no .root extension found)." << std::endl;
      return kFALSE;
   }
return kTRUE;
}


//-----------------------------------------------------------------------------
Int_t HMatrixFile::write()
{
   return 0;
}


//-----------------------------------------------------------------------------
Bool_t HMatrixFile::isOutput() const
{
   return kFALSE;
}

//-----------------------------------------------------------------------------
TFile* HMatrixFile::getOutput() const
{
   return 0;
}

//-----------------------------------------------------------------------------
const TH1* HMatrixFile::get(const char* name) const {
   return ( dynamic_cast<const TH1*>( HFile::get(name) ) );
}




