#include "hparticlefactory.h"
#include "hpidgeanttrackset.h"
#include "hgeantkine.h" 
#include "PParticle.h"
#include <TMath.h>
#include <TLorentzVector.h>

using namespace std;

// ****************************************************************************
ClassImp(HParticleFactory)

//-----------------------------------------------------------------------------
HParticleFactory::HParticleFactory(HParticlePool& ref, std::string name) : HPoolFactory( ref, name )
{
}

//-----------------------------------------------------------------------------
HParticleFactory::~HParticleFactory()
{
}


//-----------------------------------------------------------------------------
void HParticleFactory::add(EParticle p1)
{
   particleNum[ p1 ]++;
   particleComb[ p1 ] = 0;
   prongNumber = 1;
}

//-----------------------------------------------------------------------------
void HParticleFactory::add(EParticle p1, EParticle p2)
{
}

//-----------------------------------------------------------------------------
void HParticleFactory::add(EParticle p1, EParticle p2, EParticle p3)
{
}

//-----------------------------------------------------------------------------
void HParticleFactory::add(EParticle p1, EParticle p2, EParticle p3, EParticle p4)
{
}


//-----------------------------------------------------------------------------
void HParticleFactory::combine()
{
   int i1;
   particleSet.clear();
   count();
   particleSet.resize( number );

   // here all HParticle objects from HParticlePool should be combined according to pattern from mapN
   MultiParticleIter mpIter;
   MultiParticleIter mpBeginIter;

   EParticle pid =  particleComb.begin()->first;
   if ( particleComb[pid] > 0 ) // for a particle: if number of combinations > 0
   {
      for (int k=0; k < particleComb[pid]; ++k) // all combinations
      {
         i1 = ptrFH->map1[ 10 + refPool.particleNum[ pid ] ][ k ][0];
         mpBeginIter = refPool.lower_bound( particleNumIter->first );
         mpIter = mpBeginIter;
         while (--i1) ++mpIter;
         particleSet [ k ] += mpIter->second;
      }
   }

}

