#ifndef HPLUTODATA_H
#define HPLUTODATA_H

#include <TROOT.h>
#include <TFile.h>
#include <TTree.h>
#include <TClonesArray.h>
#include <TH1.h>
#include <list>
#include <functional>
#include <algorithm>
#include "PParticle.h"
#include "hdata.h"
#include "hfile.h"
#include "hparticle.h"


// ****************************************************************************
class HPlutoData : public HData
{
 public:

   HPlutoData(const HFile& source);
   ~HPlutoData(); 

   void set(int n);
   long nentries() const
   {
      return entries;
   }

   void getEntry(int n)
   {
      pTree->GetEntry(n);
   }

   int nparticles() const 
   {
      return pEvent->GetEntries();
   }

   HParticle read(int n)
   {
      return HParticle( *dynamic_cast<PParticle*>( pEvent->At(n) ));
   }


 private:

   const HFile& source;
   const int kMaxSize;
   TTree *pTree;
   TClonesArray *pEvent;
   long entries;
   int srcSize;

ClassDef(HPlutoData, 0)
};
// ****************************************************************************

#endif // HPLUTODATA_H


