#ifndef HPOOLFACTORYHANDLE_H
#define HPOOLFACTORYHANDLE_H

#include <map>
#include <vector>
#include "hparticle.h"


class HPoolFactoryHandle {

   public:

HPoolFactoryHandle() 
{
   for (int n=1; n<9; ++n)
   {
      chooseMfromN(1, n);
      chooseMfromN(2, n);
      chooseMfromN(3, n);
      chooseMfromN(4, n);
      // here we decide that no more that 4 particles of the same type can be combined
   }
}

std::map< int, std::vector< std::vector<int> > > map1; 
std::map< int, std::vector< std::vector<int> > > map2; // select 2 particles out of int
std::map< int, std::vector< std::vector<int> > > map3; 
std::map< int, std::vector< std::vector<int> > > map4; 

   private:

void chooseMfromN(int m, int n)
{
   vector<vector<int> > tempVectVect;
   if (m == 1)
   {
      for (int i=0; i<n; ++i)
      {
          vector<int> temp;
          temp.push_back(i);
          tempVectVect.push_back( temp );
      }
      map1[ 10 + n ] = tempVectVect;
   }
   else if (m == 2)
   {
      for (int i=0; i<n; ++i)
      for (int j=i+1; j<n; ++j)
      {
          vector<int> temp;
          temp.push_back(i);
          temp.push_back(j);
          tempVectVect.push_back( temp );
      }
      map2[ 20 + n ] = tempVectVect;
   }
   else if (m == 3)
   {
      for (int i=0; i<n; ++i)
      for (int j=i+1; j<n; ++j)
      for (int k=j+1; k<n; ++k)
      {
          vector<int> temp;
          temp.push_back(i);
          temp.push_back(j);
          temp.push_back(k);
          tempVectVect.push_back( temp );
      }
      map3[ 30 + n ] = tempVectVect;
   }
   else if (m == 4)
   {
      for (int i=0; i<n; ++i)
      for (int j=i+1; j<n; ++j)
      for (int k=j+1; k<n; ++k)
      for (int l=k+1; l<n; ++l)
      {
          vector<int> temp;
          temp.push_back(i);
          temp.push_back(j);
          temp.push_back(k);
          temp.push_back(l);
          tempVectVect.push_back( temp );
      }
      map4[ 40 + n ] = tempVectVect;
   }
}

}; // eof class HPoolFactoryHandle

#endif // HPOOLFACTORYHANDLE_H
